$INTERFACE U1FSU1                                             97/12/01
$REM TU
  $N='NF'
  $ADD(INTEGER,'\IMD')
  $HS=H
  $HERF='S'
  $HESR='S'
  $IF(MODEL='AF') $HESR='B'
  $IF(MODEL='AQ') $HESR='B'
  $IF(MODEL='AP') $HESR='B'
  $IF(MODEL='AA') $HESR='B'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $IF(CONSTR='U')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
    $CHECK(DECOMP,'M','M\G',2,NO)
  $ELSE
    $DECOMP='M'
  $ENDIF
  $IF(DECOMP='M')
    $IF(TYPE='L')
      $HELP
        METHOD
          1 - EXACT SOLUTION BY THE CHOLESKI DECOMPOSION
          3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,3,'1\3',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
           8 - THE HAGER SSM METHOD
      $CHECK(NUMBER,7,'1\2\3\4\5\6\7\8',2,NO)
    $ENDIF
  $ELSE
    $NUMBER=1
  $ENDIF
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2\3',4)
$REM  $JHLP=1
  $IF(DECOMP='G')
    $UPDATE='V'
    $UPTYPE='B'
    $HESR='S'
    $HELP
      VARIABLE METRIC UPDATE:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
    $CHECK(MET,1,'1\2\3',3)
  $ELSEIF(HESR='B')
    $IF(CONSTR='U')
      $HELP
        TYPE OF SPARSE UPDATE
          B - BASIC UPDATE
          F - FRACTIONED UPDATE
      $CHECK(UPTYPE,'B','B\F',3,NO)
      $HELP
        FORM OF SPARSE UPDATE:
          M - MARWILL UPDATE
          T - TOINT UPDATE
          B - PARTITIONED VARIABLE METRIC UPDATES
      $CHECK(UPDATE,'B','M\T\B',3,NO)
      $IF (UPDATE='B') $UPTYPE='B'
    $ELSE
      $UPTYPE='B'
      $HELP
        FORM OF SPARSE UPDATE:
          M - BASIC MARWILL UPDATE
          T - BASIC TOINT UPDATE
          B - PARTITIONED VARIABLE METRIC UPDATES
      $CHECK(UPDATE,'B','M\T\B',3,NO)
    $ENDIF
    $IF(UPDATE='B')
      $HELP
        METHOD CORRECTION:
          1 - NO CORRECTION
          2 - CORRECTION BY RANK ONE METHOD
          3 - CORRECTION BY RANK ONE METHOD
      $CHECK(MET3,3,'1\2\3',4)
      $SUBST('UFSET2')
      $ISNA=2
      $ADD(INIT)
        ISNA=2
      $ENDADD
    $ELSE
      $HESR='S'
    $ENDIF
  $ELSE
    $IF(CONSTR='U')
      $HELP
        TYPE OF SPARSE UPDATE
          B - BASIC UPDATE
          F - FRACTIONED UPDATE
      $CHECK(UPTYPE,'B','B\F',3,NO)
      $HELP
        FORM OF SPARSE UPDATE:
          M - MARWILL UPDATE
          T - TOINT UPDATE
      $CHECK(UPDATE,'M','M\T',3,NO)
    $ELSE
      $UPTYPE='B'
      $HELP
        FORM OF SPARSE UPDATE:
          M - BASIC MARWILL UPDATE
          T - BASIF TOINT UPDATE
      $CHECK(UPDATE,'M','M\T',3,NO)
    $ENDIF
  $ENDIF
  $IF(HESR='S')
    $IF(UPTYPE='F') $CHORDAL='NO'
    $HELP
      COMPLETION THE HESSIAN MATRIX TO HAVE A CHORDAL GRAPH
        N - COMPLETION IS NOT USED
        Y - CHORDAL COMPLETION IS PERFORMED
    $CHECK(CHORDAL,'N','NO\N\YES\Y',4,NO)
    $IF(CHORDAL='N') $CHORDAL='NO'
    $IF(CHORDAL='Y') $CHORDAL='YES'
  $ENDIF
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $IF(UPTYPE<>'B')
$REM    $IF(UPDATE<>'E')
    $SUBST('UUSAMC')
$REM    $ENDIF
  $ENDIF
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(NUMBER=3)
  $ELSEIF(NUMBER=4)
  $ELSEIF(NUMBER=5)
  $ELSE
    $SUBST('UYSFSH')
  $ENDIF
  IF (ITERM.NE.0) GO TO $90
*
*     -----------------------------
*     SPARSE VARIABLE METRIC METHOD
*     TEMPLATE : U1FSU1
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
$REM  RMAX=ETA9
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $IF(UPTYPE='F')
     KD=1
     IF(INITH.EQ.3) KD=2
  $ENDIF
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
$L=$ 30 ; $LABEL
  $SUBST('UU$(HESR)SD1')
  $IF(HESR='B')
    $IF(UPDATE='B')
      $IF(MET3=2)
        IF (IREST.NE.0) CALL UXVINP(NA,IA)
      $ENDIF
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $90
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(CONSTR='C')
    CALL UXVINB(NF,M,$IX,$JH)
    $IF(HESR='B') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(HESR='B') $SUBST('UFSET4')
  $SUBST('UYTS$(CONSTR)H')
  $DEC=DECOMP
  $IF(NUMBER=1) $DEC='G'
  $IF(NUMBER=2) $DEC='G'
  $MAT='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DEC)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DEC)$(NUMBER)')
  TXFU=TDXX
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(M,$JH)
  IF (ITERM.NE.0) GO TO $90
  IF (IREST.NE.0) GO TO $30
$L=$ 60 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  $IF(HESR='B') CALL UXVCOP(MA,$AG,$AGO)
$L=$ 70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GO TO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  $IF(CONSTR='C')
    $IF(TYPE='G')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $ENDIF
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GO TO $10
$L=$ 74 ; $LABEL
  TXFU=TSXX
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
    $IF(HESR='B') CALL UXVCOP(MA,$AGO,$AG)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(HESR='S')
    $SUBST('UYTR$(CONSTR)D')
    $IF(CONSTR='C') CALL UXVINB(NF,M,$IX,$JH)
    $IF(DEC<>DECOMP)
      IDECF=0
      ITERD=2
    $ENDIF
    $IF(UPTYPE='B')
      $IF(CHORDAL='YES')
        CALL UXVSFP(NF,$PERM,$XO,$S)
        CALL UXVSFP(NF,$PERM,$GO,$S)
      $ENDIF
      $SUBST('UUS$(UPDATE)$(DECOMP)1')
    $ELSE
      $ADD(INTEGER,'\ISNAS')
      ISNAS=ISNA
$REM      $SUBST('UUSF01')
$L=$ 82 ; $LABEL
      ASSIGN $82 TO IMD
      $SUBST('UUS$(UPDATE)$(DECOMP)3')
      GO TO ($86,$84) ISB+1
$L=$ 84 ; $LABEL
      LD=MIN(MAX(KDF,KDA)-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNA=0
      GO TO $10
$L=$ 86 ; $LABEL
      ISNA=ISNAS
    $ENDIF
  $ELSE
    $HELP
      VARIABLE METRIC UPDATE:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - RANK ONE UPDATE
    $CHECK(MET,1,'1\2\3\4',3)
$REM    $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
    $SUBST('UYTA$(CONSTR)D')
    $IF(HESR='B')
      IDECF=0
    $ENDIF
    $SUBST('UUB$(UPDATE)M1')
$REM    $IF(CONSTR='C') CALL UXVINE(MA,$JAG)
  $ENDIF
  TXFU=TUXX
$L=$75 ; $LABEL
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GO TO $20
  ELSE
  GO TO $30
  ENDIF
$L=$ 90 ; $LABEL
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FSU1'
  $ENDADD
  $EXIT
