$INTERFACE U2MSU2                                             16/12/01
$REM LU
  $F='FF'
  $FO='FFO'
  $N='NF'
  $RDEL='ONE'
  $AZL='AZL'
  $AZU='AZU'
  $ASL='AZL'
  $ASU='AZU'
  $IF(IEXT<>0)
    $AZU=AZL
  $ENDIF
  $HF=H
  $HERF='S'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $ADD(REAL,'\$X($NF)\$G($NF)\$S($NF)\$AF($NA)\$AFO($NA)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\IMD\KDS\ISNAS')
  $ADD(REAL,'\FFO\TOLP')
  $CONSTR='U'
  $TYPE='L'
  $HELP
    TYPE OF THE METHOD:
      L - LINE SEARCH
      G - TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='G'
  $ISNA=2
  $ADD(INIT)
    ISNA=2
  $ENDADD
  $HELP
    INITIAL BARRIER COEFFICIENT
  $CHECK(RPF3,'1.0$P 0',REAL,3)
  $KDS=0
$REM  $HELP
$REM    JACOBIAN MATRIX IN THE KKT SYSTEM
$REM      0 - ORIGINAL JACOBIAN MATRIX
$REM      1 - PERTURBED JACOBIAN MATRIX
$REM   $CHECK(MEP1,0,'0\1',2)
  $HELP
    SAVING EXPONENTIAL TERMS
      0 - SAVING SUPPRESSED
      1 - SAVING EXPONENTIAL TERMS
  $CHECK(MEP2,0,'0\1',2)
  $IF(MEP2>0)
    $ASL='ASL'
    $ASU='ASU'
  $ENDIF
  $HELP
    UPDATE OF THE SMOOTHING PARAMETER
      1 - GEOMETRIC SEQUENCE
      2 - MONOTONE SEQUENCE
      3 - DELAYED MONOTONE SEQUENCE
      4 - DELAYED MONOTONE SEQUENCE WITH STAGNATIONS
      5 - SPECIAL MONOTONE SEQUENCE
  $CHECK(MEP3,3,'1\2\3\4\5',2)
  $HELP
    REDUCTION OF THE SMOOTHING PARAMETER
  $CHECK(ETA4,'9.5$P-1',REAL,4)
  $HELP
    MINIMUM VALUE OF THE SMOOTHING PARAMETER
  $CHECK(ETA5,'0.0$P 0',REAL,4)
  $DEFAULT='1.0$P 0'
  $IF (MEP3=5) $DEFAULT='1.0$P-4'
  $HELP
    SWITCHING VALUE OF THE GRADIENT NORM
  $CHECK(ETA6,DEFAULT,REAL,4)
  $IF(TYPE='L')
    $NUMBER=2
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL INTERPOLATION
    $CHECK(MES,4,'1\2\3\4\5',3)
    $IF(MES=5)
      $STEP=5
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
         -1 - SPECIAL INITIAL STEPSIZE FOR THE MINIMAX APPROXIMATION
          1 - UNIT INITIAL STEPSIZE
      $CHECK(INITS,1,'-1\1',4)
    $ELSE
      $STEP=1
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
          1-UNIT INITIAL STEPSIZE
          2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR VM METHODS
          3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR CG METHODS
          4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
      $CHECK(INITS,1,'1\2\3\4',4)
    $ENDIF
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
  $ENDIF
  $HELP
    COMPUTATION OF SECOND DERIVATIVES
      1 - SECOND DERIVATIVES OF APPROXIMATING AND CONSTRAINT
          FUNCTIONS ARE COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,2,'1\2',4,NO)
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
     -1 - STEEPEST DESCENT DIRECTION
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
      4 - DIAGONAL INITIAL APPROXIMATION FOR MINIMAX
  $CHECK(INITH,3,'-1\1\2\3\4',4)
$REM  $MCL=NC
$REM   MCL=NC
  $GN='GF'
  $SN='S'
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UASET2')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
$REM  $NUM=9
  $IF(KDA=1)
    $IF(NUMDER=2) $SUBST('UYPTSH')
  $ENDIF
  $SUBST('UYSFSH')
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U2MSU2
*     --------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
$REM  ISNA=2
  R=ZERO
  FO=FMIN
  $IF(MEP3=5)
    $ADD(REAL,'\GPOM\POM1\POM2')
    $ADD(INTEGER,'\KPOM')
    KPOM=1
    GPOM=ONE
  $ENDIF
  IF (ETA5.LE.ZERO) THEN
    TOLP=SQRT(ETA0)
    TOLP=1.0$P-6
  ELSE
    TOLP=ETA5
  ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  KDS=KD
  KD=0
$L=$ 15 ; $LABEL
  $KD=1
  $SUBST('UP2MX3')
  IF (KD.LE.0) THEN
  $SUBST('UPLAG2')
  $SUBST('UP0BX2')
  ENDIF
  IF (KDS.GT.KD) THEN
  KD=KDS
  GO TO $15
  ENDIF
  ISNA=2
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT8')
  IF (ITERM.NE.0) GO TO $80
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINF(NF,M,$IX,$JH)
    CALL UXVINF(NF,MA,$IX,$JAG)
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
  $DEC=DECOMP
  $DECOMG='X'
  $IF(DEC='M') $DEC='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
  IF (NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  FFO=FF
  CALL UXVCOP(NA,$AF,$AFO)
  ASSIGN $60 TO IMD
$L=$ 60 ; $LABEL
$REM  IF(FF.LT.FFO) THEN
$REM  TSXX='DECR. FF'
$REM  ITERS=7
$REM  ENDIF
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(KBF>0)
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
$REM  ISNA=1
  GO TO $10
$L=$ 64 ; $LABEL
$REM  ISNA=2
  $IF(KDA=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  FF=FFO
  CALL UXVCOP(NA,$AFO,$AF)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ENDIF
$REM  CALL UODLA5(R,RMAX,RMAXP,RMAXD)
  $IF(MEP3=1)
    RPF3=MIN(ETA4*RPF3,GNORM**2)
  $ELSEIF(MEP3=2)
    RPF3=MIN(MAX(ETA4*RPF3,RPF3/(1.0$P 2*RPF3+ONE)),MAX(GNORM**2&
,1.0D-2**(NIT-LIT)))
  $ELSEIF(MEP3=3)
    IF (GNORM.GE.ETA6) THEN
    ELSE
    RPF3=MIN(MAX(ETA4*RPF3,RPF3/(1.0$P 2*RPF3+ONE)),MAX(GNORM**2&
,1.0D-2**(NIT-LIT)))
    ENDIF
  $ELSEIF(MEP3=4)
    IF (GNORM.GE.ETA6) THEN
    ELSE
    IF (RPF3.GE.1.0$P 2*GNORM**2) RPF3=GNORM**2
$REM    RPF3=MIN(RPF3,MAX(GNORM**2,1.0D-2**(NIT-LIT)))
    ENDIF
  $ELSE
    IF (GNORM.GE.ETA6) THEN
    ELSE IF (GPOM.LT.ONE) THEN
    KPOM=KPOM+1
    RPF3=GPOM/$DBLE(KPOM+1)
    ELSE
    KPOM=KPOM+1
    POM1=RPF3/(RPF3+1)
    POM2=TOLG/LOG($DBLE(NA))
$L=$ 68 ; $LABEL
    RPF3=HALF*RPF3
    IF (RPF3.GT.POM2) THEN
    $SUBST('UPSETG')
    IF (GNORM.GE.1.0$P-2.AND.GNORM.LE.2.0$P-1) THEN
    RPF3=MIN(RPF3,POM1)
    ELSE
    GO TO $68
    ENDIF
    ELSE
    GPOM=MIN(HALF,POM2*KPOM/(TWO*POM2+ONE))
    RPF3=GPOM/$DBLE(KPOM)
    ENDIF
    ENDIF
  $ENDIF
  RPF3=MAX(RPF3,TOLP,ETA0*ABS(FF))
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  $IF(CONSTR='C')
$L=$75 ; $LABEL
    $SUBST('UYADC0')
  $ENDIF
  GO TO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  F=FF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2MSU2'
  $ENDADD
  $ADD(SINIT)
    $SUBST('UASET1')
  $ENDADD
  $EXIT
