$INTERFACE UDDBQ1                                             97/12/01
$REM VL
  $G=GH
  $HELP
  $HELP
    WEIGHT UPDATES
      1 - WEIGHTS ARE UPDATED BY USING QUADRATIC OR
          POLYHEDRAL MODEL
      2 - WEIGHTS ARE UPDATED BY USING QUASI-NEWTON
          CONDITIONS
  $CHECK(MOS,1,'1\2',3)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    INITIAL TRUST REGION BOUND
  $CHECK(XDEL,XMAX,REAL,3)
  $HELP
    TOLERANCE FOR NEAR ACTIVITY
  $CHECK(ETA4,'1.0$P 0',REAL,4)
  $DECOMP=10
  $IF(MOS=2)
    $ADD(REAL,'\$XO($NF)\$XS($NF)\$GS($NF)')
    $ADD(REAL,'\UXVNM2')
  $ENDIF
  $ADD(REAL,'\$AF(5*($MA))\$AZ($NF+1)\$S($NF+1)\$G($NF)\$GO($NF)&
  \$H($NF)\$AG($NF*($MA))\$AFD($MAL)')
  $ADD(INTEGER,'\$IXA($NF)\$IA($MA)\$IAA($NF+1)')
  $ADD(REAL,'\UXVDOT\UXVMAX')
  $ADD(REAL,'\DELF\FS\FU\PU\TOS\WK')
  $ADD(INTEGER,'\I\K\L\IND\IEXTS')
*
*     INITIALIZATION
*
  IF (NIT.LE.LIT+1) THEN
  CALL UXVCOP(NF,$G,$GO)
  CALL UXVCOP(NF,$GO,$AG(1))
  CALL UXVSET(NF,ZERO,$S)
  RP=ZERO
  R=ZERO
  FP=F
  FU=ZERO
  PU=ZERO
  $IA(1)=2
  MAL=0
  WK=ZERO
  IND=0
  TOS=ONE
  ENDIF
*
*     MATRIX UPDATE
*
  $IF(MOS=2)
    IF (IND.GE.1.AND.ITERS.NE.9.AND.NIT.GT.LIT+3) THEN
    WK=UXVDOT(NF,$XS,$XS)
    FS=(UXVDOT(NF,$GO,$XS)-UXVDOT(NF,$GS,$XS))/WK
    WK=UXVNM2(NF,$GO,$GS)/SQRT(WK)
    TOS=MIN(MAX(ABS(FS),1.0$P-3),1.0$P 3)
    IF (FS.LT.WK*1D-3) TOS=MIN(MAX(WK,1.0$P-3),1.0$P 4)
    IND=IND+1
    ENDIF
    TO=TOS
    IF (ITERS.EQ.5) THEN
    CALL UXVCOP(NF,$XO,$XS)
    CALL UXVCOP(NF,$GO,$GS)
    IND=1+MIN(1,IND)
    ENDIF
  $ENDIF
  CALL UXVSET(NF,TO,$H)
*
*     BUNDLE VALUES UPDATE
*
  FS=F
  IF (ITERS.GE.9) FS=FS-(R-RP)*P
  DO $20 KA=1,MAL
  $AF(MA+MA+KA)=$AF(MA+MA+KA)+RP*SNORM
$20 CONTINUE
  $SUBST('UASET4')
  CALL UXVDIR(MAL,RP,$AFD,$AF(MA+1),$AF(MA+1))
  PU=PU+RP*SNORM
  FU=FU+RP*UXVDOT(NF,$AG,$S)
*
*     BUNDLE REDUCTION
*
  DO $22 L=MAL,1,-1
  IF ($IA(L).NE.0) GO TO $22
  K=(L-1)*NF+1
  DO $23 KA=L,MAL-1
  $AF(MA+KA)=$AF(MA+KA+1)
  $AF(MA+MA+KA)=$AF(MA+MA+KA+1)
  $AF(MA*3+KA)=$AF(MA*3+KA+1)
  $IA(KA)=$IA(KA+1)
  CALL UXVCOP(NF,$AG(K+NF),$AG(K))
  K=K+NF
$23 CONTINUE
  MAL=MAL-1
$22 CONTINUE
  IF (MAL.GE.MA) THEN
  K=NF+1
  DO $50 KA=2,MAL-1
  $AF(MA+KA)=$AF(MA+KA+1)
  $AF(MA+MA+KA)=$AF(MA+MA+KA+1)
  $AF(MA*3+KA)=$AF(MA*3+KA+1)
  $IA(KA)=$IA(KA+1)
  CALL UXVCOP(NF,$AG(K+NF),$AG(K))
  K=K+NF
$50 CONTINUE
  MAL=MAL-1
  ENDIF
*
*     BUNDLE COMPLETION
*
  MAL=MAX(2,MAL+1)
  K=(MAL-1)*NF+1
  $AF(MA+1)=FU
  $AF(MA+MAL)=FS
  $AF(MA+MA+1)=PU
  $AF(MA+MA+MAL)=(R-RP)*SNORM
  $AF(MA*3+MAL)=SQRT(UXVDOT(NF,$G,$G))
  DO $60 KA=1,MAL
  $AF(KA)=-MAX(ABS($AF(MA+KA)-FP),ETA5*$AF(MA+MA+KA)**2)
$60 CONTINUE
  CALL UXVCOP(NF,$G,$AG(K))
  $IA(MAL)=2
*
*     MAIN STOPPING CRITERION - SEE ALSO UYFUT4
*
  F=FP
  IF(ITERS.LE.0)F=FO
  $IF(MOS=1)
    WK=HALF*(SNORM*TO)**2+5.0$P 2*MAX(ABS(FU-FP),PU*PU)/(ABS(FP)&
    +1.0$P-3)
  $ELSEIF(MOS=2)
    WK=HALF*GNORM*SNORM+5.0$P 1*MAX(ABS(FU-FP),ETA5*PU*PU)/(ABS(FP)&
    +1.0$P-3)
  $ENDIF
  IF (NIT.LE.LIT+1) WK=ONE
  IF (WK.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  NIT=NIT-1
  GO TO $99
  ENDIF
*
*     QUADRATIC PROGRAMMING METHOD - SEE ALSO UDDXQ1
*
  IF (NTESX.GT.0.AND.NTESX.LT.NTESF) NTESF=NTESX
  IF (NIT.LE.LIT+1) DELF=ONE
  IF (FO.NE.F) DELF=ABS(FO-F)/MAX(ABS(F),ONE)
  CALL UOD1D1
  MFP=2
  MODE=1
$30 CONTINUE
  $G=GO
  $JOB=1
  $QPCON='F'
  $IF(MCL=0) $QPCON='A'
  IEXTS=IEXT
  IEXT=-1
  $IF(NUMBER=1)
    $SUBST('ULQD$(QPCON)1')
  $ELSE
    $SUBST('ULQP$(QPCON)2')
  $ENDIF
  IEXT=IEXTS
  IF (ITERQ.LT. 0) THEN
  IF (ITERQ.EQ.-1) THEN
  TDXX='NON FEAS'
  ELSE
  TDXX='INVALID '
  ENDIF
  ITERD=-2
  GO TO $70
  ENDIF
  ITERD=1
  TDXX='QD STEP '
  GMAX=UXVMAX(NF,$GO)
  IF (LCS.GT.0) THEN
  GNORM=GMAX
  SNORM=UXVMAX(NF,$S)
  ELSE
  GNORM=SQRT(UXVDOT(NF,$GO,$GO))
  SNORM=SQRT(UXVDOT(NF,$S,$S))
  ENDIF
  IF (DELF.LE.TOLF.OR.ABS(FO-F)/MAX(ABS(F),ONE).GT.ONE) THEN
  ELSE IF (GNORM.LT.TOLG*TOLG*UXVMAX(MAL-1,$AF(MA*3+2))) THEN
  I=MAL
  DO $21 KA=MAL,1,-1
  IF ($IA(KA).LT.0) I=KA
$21 CONTINUE
  IF (I.EQ.MAL) GO TO $70
  $IA(I)=0
  GO TO $30
  ENDIF
$70 IF (LCS.GT.0) THEN
  DO $80 I=1,NF
  IF ($IXA(I).GE.0) ITERD=3
$80 CONTINUE
  ENDIF
*
*     AGGREGATION
*
  FU=ZERO
  PU=ZERO
  DO $90 KA=1,NF-N
  L=$IAA(KA)
  IF (L.GT.MCL) THEN
  L=L-MCL
  IF (L.GT.0) FU=FU-$AZ(KA)*$AF(MA+L)
  IF (L.GT.0) PU=PU-$AZ(KA)*$AF(MA+MA+L)
  ENDIF
$90 CONTINUE
  CALL UXVCOP(NF,$GO,$AG(1))
*
*     PREPARATION FOR UYTRXD - TEST VALUES DETERMINATION
*
  FUB=FP
$99 CONTINUE
  CALL UOD1D2(NF,$GO,$S)
  $ADD(INIT)
    NDXX='UDDBQ1'
  $ENDADD
  $EXIT
