$INTERFACE UDGGA4                                             97/12/01
$REM LU
  $CON1='1.0$P-3'
  $IF($DEF(MOS1))
    $IF(MOS1=0)
      $GNS=GN
      $GSS=GS
      $GS=GO
    $ENDIF
  $ELSE
    $MOS1=0
    $GNS=GN
    $GSS=GS
    $GS=GO
  $ENDIF
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(JARA='D')
    $ADD(REAL,'\$AG($NF*$NA)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$GS($NF)\$AF($NA)\$AFO($NA)')
    $POM1='V'
    $POM2=')'
  $ELSEIF(JARA='S')
    $ADD(REAL,'\$AG($MA)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$GS($NF)\$AF($NA)\$AFO($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
    $ADD(REAL,'\UXUDOT\UXUNOR')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ELSEIF(JARA='L')
    $U='U'
    $UM='UM'
    $HELP
      LIMITED STORAGE UPDATE:
        1 - BROYDEN UPDATE
        2 - COLUMN  UPDATE
    $CHECK(MET,1,'1\2',3)
    $HELP
      NUMBER OF BFGS CORRECTIONS
    $CHECK(MF,5,INT,2)
    $ADD(REAL,'\$AG($MA)\$XM($NF*$MF)\$GM($NA*$MF)\$XR($MF*($MF+1)/2)&
    \$UM($MF)\$U($NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NA)\$AFO($NA)\$AFD($NF)\$AFD($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$JB($MF)\$IX($NX)')
    $ADD(REAL,'\UXUDOT\UXUNOR')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ENDIF
  $ADD(REAL,'\UXVDOT\UXVNOR\UX$(POM1)DEL')
  $ADD(REAL,'\ALF\BET\GAM\DEL\RHO\RHO1\RHO2\CK\CL')
  $DEFAULT='0.4$P 0'
  $IF(MOS=1) $DEFAULT='0.2$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  CALL UOD1D1
  IF (IDECA.NE.0) THEN
  ITERD=-1
  CALL UOERR1('UD$(JARA)GA4',1)
  TDXX='BAD DEC0'
  GO TO $70
  ENDIF
  $IF(JARA='D')
    $N='N'
    IF (LD.LE.ZERO) CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
    $IF(MOS1>0)
      IF (IDIR.EQ.0) CALL UXD$(JASA)MX($N,NA,$AG,$GS)
      CALL UX$(POM1)MUL($N,$GS,$GN,$GO,1)
      $GN=GO
    $ENDIF
  $ELSEIF(JARA='S')
    $N='NF'
    IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
    $IF(MOS1>0)
      IF (IDIR.EQ.0) CALL UXSRMX($N,NA,MA,$AG,$IAG,$JAG,$GS)
      CALL UX$(POM1)MUL($N,$GS,$GN,$GO,$POM2
      $GN=GO
    $ENDIF
  $ELSEIF(JARA='L')
    $N='NF'
    MX=MIN(NIT-KIT,MF)
    IF (LD.LE.ZERO) THEN
    CALL UXLCMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AF,$GN&
,MET)
    ENDIF
  $ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  IF (KD.LE.0) THEN
  IF (GNORM.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  GO TO $70
  ENDIF
  ENDIF
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(JARA='D')
    CALL UXD$(JASA)MM($POMA,$AG,$GN,$AFO)
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GN,$AFO)
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$GN&
,$AFO,MET)
  $ENDIF
  RHO1=UXVDOT(NA,$AFO,$AFO)
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  SNORM=ZERO
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(NF)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG(NA,$AF,$AFO)
  BET=UXVNOR(NA,$AFO)
  RHO1=MAX(ZERO,BET)
  IF(BET.GT.ZERO) THEN
  CALL UXVSCL(NA,ONE/BET,$AFO,$AFO)
  CALL UXVNEG($N,$GN,$GO)
  ALF=GNORM/BET
  RHO1=RHO1*MAX(ZERO,ALF)
  IF (ALF.GT.ZERO) THEN
  CALL UXVSCL($N,ONE/GNORM,$GO,$GO)
  CALL UXVCOP($N,$GO,$XO)
  ENDIF
  ENDIF
  TDXX='ZERO DIR'
  IF (RHO1.LE.ZERO) GO TO $20
  RHO=ALF
  GAM=BET
  DO $10 NRED=1,$N+3
*
*     BIDIAGONALIZATION
*
  $IF(JARA='D')
    CALL UXD$(JASA)MD($POMA,$AG,$GO,-ALF,$AFO,$AFO)
  $ELSEIF(JARA='S')
    CALL UXSRMD($N,NA,MA,$AG,$IAG,$JAG,$GO,-ALF,$AFO,$AFO)
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$GO&
,$AFD,MET)
    CALL UX$(POM1)DIR($N,-ALF,$AFO,$AFD,$AFO$POM2
  $ENDIF
  BET=UXVNOR(NA,$AFO)
  RHO2=MAX(ZERO,BET)
  IF(BET.GT.ZERO) THEN
  CALL UXVSCL(NA,ONE/BET,$AFO,$AFO)
  $IF(JARA='D')
    CALL UXD$(JASB)MD($POMA,$AG,$AFO,-BET,$GO,$GO)
  $ELSEIF(JARA='S')
    CALL UXSCMD($N,NA,MA,$AG,$IAG,$JAG,$AFO,-BET,$GO,$GO)
  $ELSEIF(JARA='L')
    CALL UXLCMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AFO&
,$AFD,MET)
    CALL UX$(POM1)DIR($N,-BET,$GO,$AFD,$GO$POM2
  $ENDIF
  ALF=UX$(POM1)NOR($N,$GO$POM2
  RHO2=RHO2*MAX(ZERO,ALF)
  IF (ALF.GT.ZERO) THEN
  CALL UXVSCL($N,ONE/ALF,$GO,$GO)
  ENDIF
  ENDIF
*
*     PLANE ROTATION
*
  IF (BET.LE.ZERO) THEN
  BET=GAM/RHO
  ELSE
  CALL UXVORT(RHO,BET,CK,CL,INF)
  BET=CK*(GAM/RHO)
  ENDIF
  DEL=SQRT(UX$(POM1)DEL($N,BET,$XO,$SN$POM2)
  TDXX='LSQR MAX'
  IF (DEL.GE.XDEL) GO TO $30
*
*     LSQR STEP
*
  TDXX='LSQR STP'
  CALL UX$(POM1)DIR(NF,BET,$XO,$SN,$SN$POM2
  SNORM=DEL
  RHO2=RHO2*ABS(BET)
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2.LE.PAR*RHO1) GO TO $20
  GAM=-CL*GAM
  BET=-CL*ALF/RHO
  RHO= CK*ALF
  CALL UX$(POM1)DIR($N,BET,$XO,$GO,$XO$POM2
$10 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  ITERD=2
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  GO TO $40
$30 CONTINUE
*
*     BOUNDARY STEP IS COMPUTED
*
  RHO=UX$(POM1)DOT($N,$XO,$SN$POM2
  DEL=UX$(POM1)DOT($N,$XO,$XO$POM2
  IF (BET.GE.ZERO) THEN
  CALL UNSTEP(XDEL,SNORM,RHO,DEL,ALF)
  ELSE
  RHO=-RHO
  CALL UNSTEP(XDEL,SNORM,RHO,DEL,ALF)
  ALF=-ALF
  ENDIF
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$40 CONTINUE
  $IF(JARA='D')
    CALL UXD$(JASA)MM($POMA,$AG,$SN,$AFO)
    $IF (MOS1>0)
      CALL UX$(POM1)MUL($N,$GS,$SN,$SN,1)
      $GS=GSS
      $GN=GNS
    $ENDIF
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$SN,$AFO)
    $IF (MOS1>0)
      CALL UX$(POM1)MUL($N,$GS,$SN,$SN$POM2
      $GS=GSS
      $GN=GNS
    $ENDIF
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFO,MET)
  $ENDIF
  PP=UXVDOT(NA,AFO,AFO)*HALF
$70 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)GA4'
  $ENDADD
  $EXIT
