$INTERFACE UDGGE5                                             97/12/01
$REM LU
  $CON1='1.0$P-3'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    CHOICE OF INITIAL BIORTHOGONAL VECTOR:
      1 - GRADIENT
      2 - RESIDUAL VECTOR
  $CHECK(MOS1,1,'1\2',3)
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMMOTHING
      2 - DOUBLE SMOOTHING
  $CHECK(MOS3,2,'0\1',4)
  $DEFAULT='0.4$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    PARAMETER FOR INCOMPLETE LU PRECONDITIONER
  $CHECK(ETA2,'0.0$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  $IF(JARA='D')
    $AFS=AF
    $AFP=GO
    $ADD(REAL,'\$AG($NF*$NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)\$AF($NF)\$AFO($NF)\$AFD($NF)&
    \$AFP($NF)')
  $ELSEIF(JARA='V')
    $ADD(INTEGER,'\NOS2')
    $AFS='AFS'
    $AFP='AFP'
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - QUASINEWTON PRECONDITIONING
        ABS(MOS2)=2 - QUASINEWTON PRECONDITIONING
        ABS(MOS2)=3 - TRIDIAGONAL PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,0,'-3\0\1\2\3',1)
    $IF(NUMDER=3)
    $ELSE
      $D=X
      $DL=X
      $DU=X
      $DU2=X
      $IH=IX
    $ENDIF
    $ADD(REAL,'\$D($NF)\$DL($NF)\$DU($NF)\$DU2($NF)\$GN($NF)\$SN($NF)&
    \$X($NF)\$XO($NF)\$GO($NF)\$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)&
    \$SO($NF)\$AF($NF)\$AFO($NF)\$AFS($NF)\$AFP($NF)\$AFD($NF)')
    $ADD(INTEGER,'\$IH($NF)')
  $ELSEIF(JARA='S')
    $AFS=AF
    $AFP=GA
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
        ABS(MOS2)=2 - SSOR PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,1,'-2\-1\0\1\2',1)
    $IF(MOS2=0)
      $IB=IAG
      $IW1=IAG
      $IW2=IAG
    $ENDIF
    $ADD(REAL,'\$AG($MMAX)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)\$AF($NA)\$AFO($NA)\$AFD($NA)&
    \$AFP($NF)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IB($NF)\$IW1($NF)\$IW2($NF)')
  $ELSEIF(JARA='L')
    $U='U'
    $UM='UM'
    $AFS=AF
    $AFP=GA
    $HELP
      LIMITED STORAGE UPDATE:
        1 - BROYDEN UPDATE
        2 - COLUMN  UPDATE
    $CHECK(MET,1,'1\2',3)
    $DEFAULT=5
    $IF(MET=2) $DEFAULT=3
    $HELP
      NUMBER OF CORRECTIONS
    $CHECK(MF,DEFAULT,INT,2)
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
        ABS(MOS2)=2 - SSOR PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,1,'-2\-1\0\1\2',1)
    $IF(MOS2=0)
      $IB=IAG
      $IW1=IAG
      $IW2=IAG
    $ENDIF
    $ADD(REAL,'\$AG($MMAX)\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
    \$UM($MF)\$U($NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$XS($NF)&
    \$GS($NF)\$XP($NF)\$GP($NF)\$AF($NF)\$AFO($NF)\$AFD($NF)\$AFP($NF)')
    $ADD(INTEGER,'\$IAG($NF+1)\$JAG($MA)\$IB($MF)\$JB($NF)\$IW1($NF)&
    \$IW2($NF)')
  $ENDIF
  $ADD(REAL,'\UXVDOT\UXVNOR')
  $ADD(REAL,'\ALF\BET\GAM\RHO\RHO1\RHO2\SIG\BTR(2)\BTB(3)\RMU\RNU')
  CALL UOD1D1
  $IF(JARA='D')
    $N='N'
  $ELSEIF(JARA='V')
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $N='NF'
    NOS2=$NOS2
    IF (IDECA.LT.0) IDECA=0
    IF (IDECA.EQ.2) THEN
    ELSE IF (IDECA.NE.0) THEN
    ITERD=-1
    CALL UOERR1('UD$(JARA)GE5',1)
    TDXX='BAD DEC2'
    GO TO $75
*
*     CONSTRUCTION OF PRECONDITIONER
*
    $IF(NOS2=0)
    $ELSEIF(NOS2<3)
      ELSE
      $DEFAULT=5
      $HELP
        NUMBER OF CORRECTIONS
      $CHECK(MF,DEFAULT,INT,2)
      MX=MIN(NIT-KIT,MF)
      $U='U'
      $UM='UM'
      $AFS=AF
      $AFP=GA
      $ADD(REAL,'\$UM($MF)\$U($NF)')
    $ELSEIF(NOS2=3)
      ELSE
      INF=0
      CALL UXTGGF($N,$D,$DL,$DU,$DU2,$IH,INF)
      IF (INF.NE.0) NOS2=0
      NDECA=NDECA+1
      IDECA=2
    $ENDIF
    ENDIF
  $ELSE
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(JARA='L')
      MX=MIN(NIT-KIT,MF)
    $ENDIF
    $N='NF'
    IF (IDECA.LT.0) IDECA=0
    IF (IDECA.EQ.2) THEN
    ELSE IF (IDECA.NE.0) THEN
    ITERD=-1
    CALL UOERR1('UD$(JARA)GE5',1)
    TDXX='BAD DEC2'
    GO TO $75
*
*     CONSTRUCTION OF PRECONDITIONER
*
    $IF(NOS2=1)
      ELSE
      INF=0
      CALL UXVCOP(MA,$AG,$AG(MA+1))
      CALL UXSGIF($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$IW2,ETA2,INF)
      IF (INF.LT.0) THEN
      ITERD=INF
      TDXX='DEC ERR '
      GO TO $75
      ELSE
      NDECA=NDECA+1
      IDECA=2
      ENDIF
    $ELSEIF(NOS2=2)
      ELSE
      INF=0
      CALL UXSGID($N,MA,$IAG,$JAG,$IB,$IW1,INF)
      IF (INF.LT.0) THEN
      ITERD=INF
      TDXX='DEC ERR '
      GO TO $75
      ENDIF
    $ENDIF
    ENDIF
  $ENDIF
  $IF(JARA='V')
    CALL UXVCOP($N,$AF,$GN)
    $IF(NOS2=0)
      IF(IREST.NE.0) CALL UYSET3
    $ENDIF
  $ELSEIF(MOS1=1)
    IF (LD.LE.0) THEN
    $IF(JARA='D')
      CALL UXD$(JASB)MM($N,$N,$AG,$AF,$GN)
    $ELSEIF(JARA='S')
      CALL UXSCMM($N,$N,MA,$AG,$IAG,$JAG,$AF,$GN)
    $ELSEIF(JARA='L')
      CALL UXLCMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AF,$GN&
,MET)
    $ENDIF
    ENDIF
  $ELSE
   CALL UXVCOP($N,$AF,$GN)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(JARA='V')
    XDEL=GNORM
  $ELSEIF(MOS1=1)
    $IF(JARA='D')
      CALL UXD$(JASA)MM($N,$N,$AG,$G,$AFD)
    $ELSEIF(JARA='S')
      CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$G,$AFD)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$G&
,$AFD,MET)
    $ENDIF
    RHO1=UXVDOT($N,$AFD,$AFD)
    RHO2=GNORM*GNORM
    IF (RHO1.LE.ZERO) THEN
    XDEL=GNORM
    ELSE
    XDEL=(RHO2/RHO1)*GNORM
    ENDIF
  $ELSE
    XDEL=GNORM
  $ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  PAR=SQRT(F/FO)**1.618$P 0
  PAR=MAX(PAR,SQRT(SQRT(TWO*F)))
  PAR=MIN(EPS6,PAR)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,HALF**($DBLE(NIT-LIT)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  RHO2=UXVDOT($N,$AF,$AF)
*
*     PRELIMINARY INEXACT SOLUTION
*
  $IF(JARA='D')
  $ELSEIF(JARA='V')
    CALL UXVCOP($N,$X,$SO)
    CALL UXVCOP($N,$AF,$AFS)
    $IF(MOS2=3)
      IF (MOS2.NE.3) GO TO $11
      CALL UXVNEG($N,$AF,$SN)
      CALL UXTGGB($N,$D,$DL,$DU,$DU2,$IH,$SN,0)
      SNORM=SQRT(UXVDOT($N,$SN,$SN))
      FO=F
      PP=SQRT(ETA0)/SNORM
      CALL UXVDIR($N,PP,$SN,$SO,$X)
      CALL UYSET2
      ASSIGN $10 TO IMD
      GO TO $LMD
$10   CONTINUE
      IF (F.EQ.FO) THEN
      NOS2=0
      GO TO $11
      ENDIF
      F=FO
      CALL UXVDIF($N,$AF,$AFS,$AFD)
      CALL UXVSCL($N,ONE/PP,$AFD,$AFD)
      CALL UXVSUM($N,$AFS,$AFD,$AFO)
      RHO1=UXVDOT($N,$AFO,$AFO)
      IF (RHO1.GT.PAR*RHO2) GO TO $11
      P=UXVDOT($N,$AFD,$AFS)
      PP=UXVDOT($N,$AFD,$AFD)*HALF
      IF (SNORM.LE.XDEL) THEN
      ITERD=2
      TDXX='TLU  REG'
      ELSE
      ALF=XDEL/SNORM
      CALL UXVSCL($N,ALF,$SN,$SN)
      SNORM=XDEL
      P=P*ALF
      PP=PP*ALF**2
      ITERD=3
      TDXX='TLU  MAX'
      ENDIF
      CALL UXVCOP($N,$SO,$X)
      CALL UXVCOP($N,$AFS,$AF)
      GO TO $75
$11   CONTINUE
    $ENDIF
  $ELSEIF(MOS2=1)
    CALL UXVNEG($N,$AF,$SN)
    CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$SN,$XO,0)
    $IF(JARA='S')
      CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFO,MET)
      CALL UXVSUM($N,$AF,$AFO,$AFO)
    $ENDIF
    RHO1=UXVDOT($N,$AFO,$AFO)
    IF (RHO1.LE.PAR*RHO2) THEN
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    IF (SNORM.LE.XDEL) THEN
    ITERD=1
    TDXX='ILU  REG'
    ELSE
    CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
    SNORM=XDEL
    ITERD=3
    TDXX='ILU  MAX'
    ENDIF
    GO TO $60
    ENDIF
  $ELSEIF(MOS2=2)
    CALL UXVNEG($N,$AF,$SN)
    CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$SN,$XO,1.0$P 0,0)
    $IF(JARA='S')
      CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFO,MET)
      CALL UXVSUM($N,$AF,$AFO,$AFO)
    $ENDIF
    RHO1=UXVDOT($N,$AFO,$AFO)
    IF (RHO1.LE.PAR*RHO2) THEN
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    IF (SNORM.LE.XDEL) THEN
    ITERD=1
    TDXX='SSOR REG'
    ELSE
    CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
    SNORM=XDEL
    ITERD=3
    TDXX='SSOR MAX'
    ENDIF
    GO TO $60
    ENDIF
  $ENDIF
*
*     BICGSTAB INITIATION
*
  ITERD=2
  SNORM=ZERO
  RHO=ONE
  ALF=ONE
  GAM=ONE
  CALL UXVNEG($N,$AFS,$AFO)
  CALL UXVNEG($N,$AFS,$AFD)
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVSET($N,ZERO,$XO)
  CALL UXVSET($N,ZERO,$GO)
  CALL UXVSET($N,ZERO,$XP)
  NRED=0
*
*     BICGSTAB ITERATIONS
*
$20 CONTINUE
  NRED=NRED+1
  IF (NRED.GT.2*N) GO TO $50
  RHO1=RHO
  IF (RHO1.EQ.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UD$(JARA)GE5',4)
  GO TO $75
  ENDIF
  RHO=UXVDOT($N,$GN,$AFD)
  BET=(RHO/RHO1)*(ALF/GAM)
  CALL UXVDIR($N,-GAM,$XP,$GO,$GO)
  CALL UXVDIR($N,BET,$GO,$AFD,$GO)
*
*     BICGSTAB PRECONDITIONING
*
  $IF(JARA='D')
    CALL UXVCOP($N,$GO,$AFP)
    CALL UXD$(JASA)MM($N,$N,$AG,$GO,$XP)
  $ELSEIF(JARA='V')
    CALL UXVCOP($N,$GO,$AFP)
    $IF(NOS2=0)
    $ELSEIF(NOS2<3)
      CALL UXPRMM($N,MX,$XM,$GM,$JB,$XR,$UM,$U,$GO,$AFP,NOS2)
    $ELSEIF(NOS2=3)
      IF (NOS2.EQ.3) THEN
      CALL UXTGGB($N,$D,$DL,$DU,$DU2,$IH,$AFP,0)
      ENDIF
    $ENDIF
    PP=SQRT(ETA0/UXVDOT($N,$AFP,$AFP))
    CALL UXVDIR($N,PP,$AFP,$SO,$X)
    FO=F
    CALL UYSET2
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    F=FO
    CALL UXVDIF($N,$AF,$AFS,$XP)
    CALL UXVSCL($N,ONE/PP,$XP,$XP)
  $ELSE
    CALL UXVCOP($N,$GO,$AFP)
    $IF(NOS2=1)
      CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$AFP,$XP,0)
    $ELSEIF(NOS2=2)
      CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$AFP,$XP,1.0$P 0,0)
    $ENDIF
    $IF(JARA='S')
      CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$AFP,$XP)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$AFP&
,$XP,MET)
    $ENDIF
  $ENDIF
  SIG=UXVDOT($N,$GN,$XP)
  IF (SIG.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UD$(JARA)GE5',5)
  GO TO $75
  ENDIF
  ALF=RHO/SIG
  CALL UXVDIR($N,-ALF,$XP,$AFD,$GS)
  CALL UXVCOP($N,$GS,$XS)
*
*     BICGSTAB PRECONDITIONING
*
  $IF(JARA='D')
    CALL UXD$(JASA)MM($N,$N,$AG,$GS,$GP)
  $ELSEIF(JARA='V')
    $IF(NOS2=0)
    $ELSEIF(NOS2<3)
      CALL UXPRMM($N,MX,$XM,$GM,$JB,$XR,$UM,$U,$GO,$GS,NOS2)
    $ELSEIF(NOS2=3)
      IF (NOS2.EQ.3) THEN
      CALL UXTGGB($N,$D,$DL,$DU,$DU2,$IH,$XS,0)
      ENDIF
    $ENDIF
    PP=SQRT(ETA0/UXVDOT($N,$XS,$XS))
    CALL UXVDIR($N,PP,$XS,$SO,$X)
    FO=F
    CALL UYSET2
    ASSIGN $40 TO IMD
    GO TO $LMD
$40 CONTINUE
    F=FO
    CALL UXVDIF($N,$AF,$AFS,$GP)
    CALL UXVSCL($N,ONE/PP,$GP,$GP)
  $ELSE
    $IF(NOS2=1)
      CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$XS,$GP,0)
    $ELSEIF(NOS2=2)
      CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$XS,$GP,1.0$P 0,0)
    $ENDIF
    $IF(JARA='S')
      CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$XS,$GP)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$XS&
,$GP,MET)
    $ENDIF
  $ENDIF
  GAM=UXVDOT($N,$GS,$GP)
  IF (GAM.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UD$(JARA)LE5',5)
  GO TO $75
  ENDIF
*
*     BICGSTAB STEP
*
  GAM=GAM/UXVDOT($N,$GP,$GP)
  CALL UXVDIR($N,-GAM,$GP,$GS,$AFD)
  CALL UXVDIR($N,GAM,$XS,$XO,$XO)
  CALL UXVDIR($N,ALF,$AFP,$XO,$XO)
*
*     BICGSTAB SMOOTHING
*
  $IF(MOS3<0)
    CALL UXVCOP($N,$AFD,$AFO)
    CALL UXVCOP($N,$XO,$SN)
  $ELSE
    RMU=ETA0**2
    CALL UXVDIF($N,$AFO,$AFD,$GP)
    BTB(1)=UXVDOT($N,$GP,$GP)
    BTR(1)=UXVDOT($N,$GP,$AFD)
    $IF(MOS3=2)
      BTB(2)=UXVDOT($N,$GP,$XP)
      BTB(3)=UXVDOT($N,$XP,$XP)
      BTR(2)=UXVDOT($N,$XP,$AFD)
      CALL UXDPGF(2,BTB,INF,RMU,RNU)
      CALL UXDPGB(2,BTB,BTR,0)
      RMU=-BTR(1)
      RNU=-BTR(2)
    $ELSE
      RMU=-BTR(1)/MAX(BTB(1),RMU)
    $ENDIF
    CALL UXVDIR($N,RMU,$GP,$AFD,$AFO)
    CALL UXVDIF($N,$SN,$XO,$GP)
    CALL UXVDIR($N,RMU,$GP,$XO,$GS)
    $IF(MOS3=2)
      CALL UXVDIR($N,RNU,$XP,$AFO,$AFO)
      CALL UXVDIR($N,-RNU,$AFP,$GS,$GS)
    $ENDIF
  $ENDIF
  TDXX='CGS MAX2'
  BET=UXVNOR($N,$GS)
  IF (BET.GE.XDEL) GO TO $55
  CALL UXVCOP($N,$GS,$SN)
  SNORM=BET
  ITERD=2
  TDXX='CGS STEP'
  RHO1=UXVDOT($N,$AFO,$AFO)
  CALL UOD1D4(RHO2,RHO1,PAR,SNORM,XDEL)
  IF (RHO1.LE.PAR*RHO2) GO TO $60
  GO TO $20
$50 CONTINUE
*
*     AN INEXACT SOLUTION IS OBTAINED
*
  TDXX='MAX ITER'
  GO TO $60
$55 CONTINUE
*
*     BOUNDARY STEP IS COMPUTED
*
  CALL UXVDIF($N,$GS,$SN,$XO)
  RHO1=UXVDOT($N,$XO,$SN)
  RHO2=UXVDOT($N,$XO,$XO)
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UXVDIR($N,ALF,$XO,$SN,$SN)
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$60 CONTINUE
  $IF(JARA='D')
    CALL UXD$(JASA)MM($N,$N,$AG,$SN,$AFD)
  $ELSEIF(JARA='V')
    FO=F
    PP=SQRT(ETA0)/SNORM
    CALL UXVDIR($N,PP,$SN,$SO,$X)
    CALL UYSET2
    ASSIGN $65 TO IMD
    GO TO $LMD
$65 CONTINUE
    F=FO
    CALL UXVDIF($N,$AF,$AFS,$AFD)
    CALL UXVSCL($N,ONE/PP,$AFD,$AFD)
    CALL UXVCOP($N,$SO,$X)
    CALL UXVCOP($N,$AFS,$AF)
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$SN,$AFD)
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFD,MET)
  $ENDIF
$70 CONTINUE
  $IF(JARA='V')
    P=UXVDOT($N,$AF,$AFD)
  $ELSEIF(MOS1=1)
    P=UXVDOT($N,$SN,$GN)
  $ELSE
    P=UXVDOT($N,$AF,$AFD)
  $ENDIF
  PP=UXVDOT($N,$AFD,$AFD)*HALF
$75 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(JARA='V')
    CALL UXVCOP($N,$SO,$X)
    CALL UXVCOP($N,$AFS,$AF)
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(JARA)GE5'
  $ENDADD
  $EXIT
