$INTERFACE UDLLI3                                             97/12/01
$REM LU
  $CON1='1.0$P-3'
  $SOS=SO
  $SO=GA
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,6,INT,2)
  $IF(UPDATE='NO')
    MF=0
  $ENDIF
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    CHOICE OF INITIAL BIORTHOGONAL VECTOR:
      1 - GRADIENT
      2 - RESIDUAL VECTOR
  $CHECK(MOS1,2,'1\2',3)
  $HELP
    PRECONDITIONING TECHNIQUE
      ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
      ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
      ABS(MOS2)=2 - SSOR PRECONDITIONING
      MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
      MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                 BY PRECONDITIONED ITERATIVE PROCESS
  $CHECK(MOS2,1,'-2\-1\0\1\2',1)
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMMOTHING
      2 - DOUBLE SMOOTHING
  $CHECK(MOS3,2,'0\1',4)
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'0.25$P 0',REAL,4)
  $HELP
    PARAMETER FOR INCOMPLETE LU PRECONDITIONER
  $CHECK(ETA2,'0.0$P 0',REAL,4)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  $IF(MOS2=0)
    $IB=IAG
    $IW1=IAG
    $IW2=IAG
  $ENDIF
  $ADD(REAL,'\$AG($MMAX)\$XM($NF*$MF)\$GM($MF)\$GN($NF)\$SN($NF)&
  \$XO($NF)\$GO($NF)\$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)\$AF($NA)&
  \$AFO($NA)\$AFD($NA)\$SO($NF)')
  $ADD(INTEGER,'\$IAG($NF+1)\$JAG($MA)\$IB($NF)\$IW1($NF)\$IW2($NF)&
  \$IH($MF)')
  $ADD(INTEGER,'\MM')
  $ADD(REAL,'\UXVDOT\UXVNOR')
  $ADD(REAL,'\ALF\BET\RHO\RHO1\RHO2\SIG\BTR(2)\BTB(3)\RMU\RNU')
  $N='NF'
  $NOS2=0
  $IF(MOS2= 1) $NOS2=1
  $IF(MOS2=-1) $NOS2=1
  $IF(MOS2= 2) $NOS2=2
  $IF(MOS2=-2) $NOS2=2
  CALL UOD1D1
  MM=NIT-KIT
  IF (MM.EQ.0) THEN
  $IF(NOS2=1)
    INF=0
    CALL UXVCOP(MA,$AG,$AG(MA+1))
    CALL UXSGIF($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$IW2,ETA2,INF)
  $ELSEIF(NOS2=2)
    INF=0
    CALL UXSGID($N,MA,$IAG,$JAG,$IB,$IW1,INF)
  $ENDIF
  IF (INF.LT.0) THEN
  ITERD=INF
  TDXX='DEC ERR.'
  GO TO $40
  ELSE
  NDECA=NDECA+1
  ENDIF
  ELSE
  CALL UXLIIM($N,MA,MM,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$XM,$GM,$IH,$AF&
,$SN,$XO)
  CALL UXVNEG($N,$SN,$SN)
  INITD=MAX(ABS(INITD),1)
  ITERD = 1
  TDXX='INV FORM'
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  GNORM=SNORM
  GO TO $20
  ENDIF
  $IF(MOS1=1)
    IF (LD.LE.ZERO) CALL UXSCMM($N,$N,MA,$AG,$IAG,$JAG,$AF,$GN)
  $ELSE
   CALL UXVCOP($N,$AF,$GN)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  PAR=SQRT(F/FO)**1.618$P 0
  PAR=MAX(PAR,SQRT(SQRT(TWO*F)))
  PAR=MIN(EPS6,PAR)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE($N)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  RHO=ONE
  RHO2=UXVDOT($N,$AF,$AF)
  $IF(MOS2=1)
    CALL UXVNEG($N,$AF,$SN)
    CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$SN,$XO,0)
    CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    RHO1=UXVDOT($N,$AFO,$AFO)
    IF (RHO1.LE.PAR*RHO2) THEN
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    ITERD=1
    TDXX='ILU  REG'
    GO TO $20
    ENDIF
  $ELSEIF(MOS2=2)
    CALL UXVNEG($N,$AF,$SN)
    CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$SN,$XO,1.0$P 0,0)
    CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    RHO1=UXVDOT($N,$AFO,$AFO)
    IF (RHO1.LE.PAR*RHO2) THEN
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    ITERD=1
    TDXX='SSOR REG'
    GO TO $20
    ENDIF
  $ENDIF
  ITERD=2
  SNORM = ZERO
  CALL UXVNEG($N,$AF,$AFO)
  CALL UXVNEG($N,$AF,$AFD)
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVSET($N,ZERO,$XO)
  CALL UXVSET($N,ZERO,$GO)
  CALL UXVSET($N,ZERO,$XS)
  SIG=UXVNOR($N,$AFD)
  DO $10 NRED=1,2*N
  RHO1=RHO
  IF (RHO1.EQ.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UDLLI3',4)
  GO TO $40
  ENDIF
  RHO=UXVDOT($N,$GN,$AFD)
  BET=RHO/RHO1
  CALL UXVDIR($N,BET,$XS,$AFD,$GS)
  CALL UXVDIR($N,BET,$GO,$XS,$GO)
  CALL UXVDIR($N,BET,$GO,$GS,$GO)
  CALL UXVCOP($N,$GO,$SO)
  $IF(NOS2=1)
    CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$SO,$XP,0)
  $ELSEIF(NOS2=2)
    CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$SO,$XP,1.0$P 0,0)
  $ENDIF
  CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$SO,$XP)
  SIG=UXVDOT($N,$GN,$XP)
  IF (SIG.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UDLLI3',5)
  GO TO $40
  ENDIF
  ALF=RHO/SIG
  CALL UXVDIR($N,-ALF,$XP,$GS,$XS)
  CALL UXVSUM($N,$GS,$XS,$GS)
  $IF(NOS2=1)
    CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$GS,$GP,0)
  $ELSEIF(NOS2=2)
    CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$GS,$GP,1.0$P 0,0)
  $ENDIF
  CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$GS,$GP)
  CALL UXVDIR($N,-ALF,$GP,$AFD,$AFD)
  CALL UXVDIR($N,ALF,$GS,$XO,$XO)
*
*     CG SMOOTHING
*
  $IF(MOS3=0)
    CALL UXVCOP($N,$AFD,$AFO)
    CALL UXVCOP($N,$XO,$SN)
  $ELSE
    RMU=ETA0**2
    CALL UXVDIF($N,$AFO,$AFD,$GP)
    BTB(1)=UXVDOT($N,$GP,$GP)
    BTR(1)=UXVDOT($N,$GP,$AFD)
    $IF(MOS3=2)
      BTB(2)=UXVDOT($N,$GP,$XP)
      BTB(3)=UXVDOT($N,$XP,$XP)
      BTR(2)=UXVDOT($N,$XP,$AFD)
      CALL UXDPGF(2,BTB,INF,RMU,RNU)
      CALL UXDPGB(2,BTB,BTR,0)
      RMU=-BTR(1)
      RNU=-BTR(2)
    $ELSE
      RMU=-BTR(1)/MAX(BTB(1),RMU)
    $ENDIF
    CALL UXVDIR($N,RMU,$GP,$AFD,$AFO)
    CALL UXVDIF($N,$SN,$XO,$GP)
    CALL UXVDIR($N,RMU,$GP,$XO,$SN)
    $IF(MOS3=2)
      CALL UXVDIR($N,RNU,$XP,$AFO,$AFO)
      CALL UXVDIR($N,-RNU,$SO,$SN,$SN)
    $ENDIF
  $ENDIF
  SNORM=UXVNOR($N,$SN)
  TDXX='CGS MAX2'
  IF (SNORM.GE.XMAX) GO TO $20
  TDXX='CGS STEP'
  RHO1=UXVDOT($N,$AFO,$AFO)
  CALL UOD1D4(RHO2,RHO1,PAR,SNORM,XDEL)
  IF (RHO1.LE.PAR*RHO2) GO TO $20
$10 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  P=-F
$40 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $SO=SOS
  $ADD(INIT)
  NDXX='UDLLI3'
  $ENDADD
