$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZLINS                                     01/12/94 +
$REM + SI                                                            +
$REM + PURPOSE:  LINE SEARCH SELECTION                               +
$REM +---------------------------------------------------------------+

$IF(TYPE='L')
  $NONMONOTONE=0
  $HELP
    SPECIFICATION OF THE SEARCH:
      B - BASIC LINE SEARCH
      H - HAGER LINE SEARCH
      M - LINE SEARCH WITH TRUST REGION BOUND
      N - NONMONOTONE LINE SEARCH
  $CHECK(SEARCH,'B','B\H\M\N',3,NO)
  $IF(SEARCH='H')
    $IF($DEF(STEP)) $ERASE(STEP)
  $ELSEIF(SEARCH='M')
    $ADD(SINID)
      MES=-ABS(MES)
    $ENDADD
  $ELSEIF(SEARCH='N')
    $NONMONOTONE=1
  $ENDIF
  $IF($DEF(STEP))
    $IF(KDS=0)
      $HELP
        TERMINATION CRITERION:
          NEGATIVE-NONMONOTONE STEPSIZE
                   (= MINUS NUMBER OF NONMONOTONE STEPS)
                 1-PERFECT LINE SEARCH
                 2-GOLDSTEIN STEPSIZE
                 5-ARMIJO STEPSIZE
                 6-FIRST STEPSIZE
      $CHECK(KTERS,5,'-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\1\2\5\6',3)
      $IF(STEP=1)
        $STEP=2
$REM        $IF(KTERS=2) $STEP=1
        $IF(KTERS<0) $STEP=3
      $ENDIF
    $ELSE
      $HELP
        TERMINATION CRITERION:
          NEGATIVE-NONMONOTONE STEPSIZE
                   (= MINUS NUMBER OF NONMONOTONE STEPS)
                 1-PERFECT LINE SEARCH
                 2-GOLDSTEIN STEPSIZE
                 3-WEAK WOLFE STEPSIZE
                 4-STRONG WOLFE STEPSIZE
                 5-ARMIJO STEPSIZE
                 6-FIRST STEPSIZE
      $CHECK(KTERS,3,'-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\1\2\3\4\5\6',3)
      $IF(STEP=1)
        $STEP=2
$REM        $IF(KTERS=3) $STEP=1
        $IF(KTERS<0) $STEP=3
      $ENDIF
    $ENDIF
  $ELSE
    $IF(KDS=0)
      $HELP
        TERMINATION CRITERION:
          NEGATIVE-NONMONOTONE STEPSIZE
                   (= MINUS NUMBER OF NONMONOTONE STEPS)
                 1-PERFECT LINE SEARCH
                 2-GOLDSTEIN STEPSIZE
                 5-ARMIJO STEPSIZE
                 6-FIRST STEPSIZE
      $CHECK(KTERS,2,'-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\1\2\5\6',3)
      $STEP=2
      $IF(KTERS=2) $STEP=1
      $IF(KTERS<0) $STEP=3
    $ELSEIF(SEARCH='H')
      $KDS=1
      $STEP=10
    $ELSE
      $HELP
        TERMINATION CRITERION:
          NEGATIVE-NONMONOTONE STEPSIZE
                   (= MINUS NUMBER OF NONMONOTONE STEPS)
                 1-PERFECT LINE SEARCH
                 2-GOLDSTEIN STEPSIZE
                 3-WEAK WOLFE STEPSIZE
                 4-STRONG WOLFE STEPSIZE
                 5-ARMIJO STEPSIZE
                 6-FIRST STEPSIZE
      $CHECK(KTERS,3,'-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\1\2\3\4\5\6',3)
      $STEP=2
      $IF(KTERS=3) $STEP=1
      $IF(KTERS<0) $STEP=3
    $ENDIF
  $ENDIF
$ELSEIF(TYPE='G')
  $NONMONOTONE=0
  $HELP
    SPECIFICATION OF THE SEARCH:
      B - BASIC TRUST REGION
      M - TRUST REGION WITH LINE SEARCH
      N - NONMONOTONE TRUST REGION
  $CHECK(SEARCH,'B','B\M\N',3,NO)
  $IF(SEARCH='M') 
    $STEP=4
  $ELSEIF(SEARCH='N')
    $NONMONOTONE=1
  $ENDIF  
  $HELP
    SIMPLE SEARCH SELECTION:
      1 - SIMPLE SEARCH
      2 - SIMPLE SEARCH FOR NONLINEAR EQUATIONS
  $CHECK(STEP,1,'1\2\4',4,NO)
  $HELP
    TERMINATION CRITERION:
      NEGATIVE-NONMONOTONE STEPSIZE
               (= MINUS NUMBER OF NONMONOTONE STEPS)
             0-MONOTONE STEPSIZE
             6-FIRST STEPSIZE
  $CHECK(KTERS,0,'-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\0\6',3)
  $IF(KTERS<0) $STEP=3
$ELSE
  $HELP
    CUBIC REGULARIZATION PARAMETETR UPDATE:
      1 - SIMPLE PARAMETER UPDATE
      2 - MORE SOPHISTICAL PARAN\METER UPDATE
  $CHECK(STEP,1,'1\2',4,NO)
$ENDIF

$KDS1=KDS
$IF(KDS1>1) $KDS1=1
$IF(TYPE='G') $KDS1=0
$IF(STEP<10)
  $SUBST('US$KDS1$(TYPE)0$STEP')
$ELSE
  $SUBST('US$KDS1$(TYPE)$STEP')
$ENDIF

$ERASE(STEP)


