$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZMETH                                    01/12/94  +
$REM + SI                                                            +
$REM + PURPOSE:  SUBSTITUTION OF METHOD                              +
$REM +---------------------------------------------------------------+

$IF(METHODINIT=.FALSE.)
  $INITIATION
$ENDIF

$METHODINIT=.FALSE.

$SINIT=SUBIT
$SINID=SUBID
$ADD(INIT)
  ETA0=$ETA0
  ETA9=$ETA9
  ITR=6
  IRD=5
  IWR=2
  NEXT=$NEXT
$ENDADD

$HELP
  STANDARD TEST OF EXTERNAL SUBROUTINES:
    N - NO TEST
    Y - PERFORM TEST BEFORE SOLUTION
    A - PERFORM TEST AFTER SOLUTION
    O - PERFORM ONLY TEST (WITHOUT SOLUTION)
$CHECK(TEST,'N','NO\N\YES\Y\AFTER\A\ONLY\O',1,NO)
$IF(TEST='N') $TEST='NO'
$IF(TEST='Y') $TEST='YES'
$IF(TEST='A') $TEST='AFTER'
$IF(TEST='O') $TEST='ONLY'
$IF(TEST='ONLY')
  $GRAPH='NO'
  $SUBST('UZTEST')
$ELSE
  $IF(TEST='YES') $SUBST('UZTEST')
  CALL UYCLST
  $ADD(SINIT)
    CALL UYPARD
  $ENDADD  
  $OPTION(LFORTO=.FALSE.)
  $$SINID$NMET
  $OPTION(LFORTO=.TRUE.)
  $IF($DEF(CONST)) $CONST

  $HELP
    LEVEL OF TEXT FILE OUTPUT:
       ABS(KOUT)=0 - NO PRINT OR PAPER SAVING PRINT
       ABS(KOUT)=1 - STANDARD PRINT OF ITERATIONS
       ABS(KOUT)=2 - ADDITIONAL PRINT OF STEPSIZE SELECTION
       ABS(KOUT)=3 - ADDITIONAL PRINT OF DIRECTION DETERMINATION
                     AND VARIABLE METRIC UPDATE
       ABS(KOUT)=4 - ADDITIONAL PRINT OF CONSTRAINT HANDLING
       ABS(KOUT)=5 - ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION
    KOUT<0 - ADDITIONAL PRINT OF DATA AND OPTIONS IN THE HEADING
  $CHECK(KOUT,0,'-5\-4\-3\-2\-1\0\1\2\3\4\5',1)
  $IF(KOUT<>0)
    $HELP
      FIRST ITERATION IN THAT AN INFORMATION IS PRINTED
    $CHECK(KOUT1,0,INT,1)
    $HELP
      LAST ITERATION IN THAT AN INFORMATION IS PRINTED
    $CHECK(KOUT2,10,INT,1)
    $HELP
      NUMBER OF ITERATIONS AFTER THAT AN INFORMATION IS
      PRINTED
    $CHECK(KOUT3,1,INT,1)
    $HELP
      LEVEL OF TEXT FILE OUTPUT:
        ABS(LOUT)=0 - STANDARD PRINT
        ABS(LOUT)=1 - ADDITIONAL PRINT OF THE VECTOR OF VARIABLES
        ABS(LOUT)=2 - ADDITIONAL PRINT OF THE GRADIENT
        ABS(LOUT)=3 - ADDITIONAL PRINT OF THE HESSIAN MATRIX
        ABS(LOUT)=4 - ADDITIONAL PRINT FOR DEBUGGING
      LOUT<0 - ADDITIONAL PRINT OF APPROXIMATING FUNCTIONS AND
               CONSTRAINTS
    $CHECK(LOUT,0,'-4\-3\-2\-1\0\1\2\3\4',1)
  $ELSE
    $DEFAULT=2
    $IF(NC>NCL) $DEFAULT=1
    $IF(COLLECTION<>'NO') $DEFAULT=2
    $HELP
      LEVEL OF TEXT FILE OUTPUT:
        0 - NO PRINT
        1 - COPY OF THE BASIC SCREEN OUTPUT
            STANDARD FINAL OUTPUT
        2 - COPY OF THE BASIC SCREEN OUTPUT
            FINAL OUTPUT WITH TERMINATION CRITERION
       -1 - PAPER SAVING PRINT
    $CHECK(LOUT,DEFAULT,'-1\0\1\2',1)
    $ADD(INIT)
      KOUT1=0
      KOUT2=10
      KOUT3=1
    $ENDADD
  $ENDIF

  $IF(GRAPH='NO')
    $IF(DISPLAY='NO')
      $IF(COLLECTION='NO')
        $DEFAULT= 2
      $ELSE
        $DEFAULT=-1
      $ENDIF
      $HELP
        LEVEL OF BASIC SCREEN OUTPUT:
           ABS(MOUT)=0 - NO OUTPUT
           ABS(MOUT)=1 - FINAL OUTPUT
           ABS(MOUT)=2 - ADDITIONAL OUTPUT IN EACH ITERATION
           ABS(MOUT)=3 - ADDITIONAL FINAL OUTPUT OF LINEAR OR
                         QUADRATIC PROGRAMMING
           ABS(MOUT)=4 - ADDITIONAL OUTPUT IN EACH ITERATION
                         OF LINEAR OR QUADRATIC PROGRAMMING
        MOUT<0 - OUTPUT WITH PRINTED OPTIONS
      $CHECK(MOUT,DEFAULT,'-4\-3\-2\-1\0\1\2\3\4',1)
      $IF (MOUT=0) $NOUT=0
    $ELSE
      $HELP
        LEVEL OF BASIC SCREEN OUTPUT:
           1 - FINAL OUTPUT
           2 - FINAL OUTPUT TOGETHER WITH
                  OUTPUT IN EACH ITERATION
      $CHECK(MOUT,1,'1\2',1)
      $NOUT=0
    $ENDIF
  $ELSE
    $DEFAULT=1
    $SCANING=0
    $COLOR=16
    $ADD(INIT)
      OPEN(4,FILE='P.DUM',STATUS='UNKNOWN')
      ITR=4
    $ENDADD
    $HELP
      LEVEL OF BASIC SCREEN OUTPUT:
         ABS(MOUT)=0 - NO OUTPUT
         ABS(MOUT)=1 - FINAL OUTPUT
         ABS(MOUT)=2 - ADDITIONAL OUTPUT IN EACH ITERATION
         ABS(MOUT)=3 - ADDITIONAL FINAL OUTPUT OF LINEAR OR
                       QUADRATIC PROGRAMMING
         ABS(MOUT)=4 - ADDITIONAL OUTPUT IN EACH ITERATION
                       OF LINEAR OR QUADRATIC PROGRAMMING
      MOUT<0 - FINAL OUTPUT WITH TERMINATION CRITERION
    $CHECK(MOUT,DEFAULT,'-4\-3\-2\-1\0\1\2\3\4',1)
    $IF (MOUT=0) $NOUT=0
    $IF($DEF(NF))
      $DEFAULT=1
      $IF(GRAPH='INTERNAL')
        $IF(NF>100) $DEFAULT=0
      $ENDIF
      $IF(DEFAULT=0)
        $IF(PATH='E') $PATH='Y'
        $IF(PATH='EXTENDED') $PATH='YES'
        $HELP
          SPECIFICATION OF GRAPHICAL PATH:
            N - GRAPHICAL PATH SUPPRESSED
            Y - GRAPHICAL PATH REQUIRED
        $CHECK(PATH,'N','NO\N\YES\Y',1,NO)
        $IF(PATH='N') $PATH='NO'
        $IF(PATH='Y') $PATH='YES'
      $ELSE
        $HELP
          SPECIFICATION OF GRAPHICAL PATH:
            N - GRAPHICAL PATH SUPPRESSED
            Y - GRAPHICAL PATH REQUIRED
            E - EXTENDED GRAPHICAL PATH REQUIRED
        $CHECK(PATH,'N','NO\N\YES\Y\EXTENDED\E',1,NO)
        $IF(PATH='N') $PATH='NO'
        $IF(PATH='Y') $PATH='YES'
        $IF(PATH='E') $PATH='EXTENDED'
      $ENDIF
      $IF(PATH<>'NO')
        $HELP
          NUMBER OF POINTS ON THE GRAPHICAL PATH
        $CHECK(NPA,100,INT,1)
      $ENDIF
    $ELSE
      $PATH='NO'
    $ENDIF
    $IF(GRAPH='EXTERNAL')
      $IF($DEF(ISO))
        $IF(ISO='N') $ISO='NO'
        $IF(ISO='Y') $ISO='YES'
        $IF(ISO='E') $ISO='EXTENDED'
      $ELSE
        $ISO='NO'  
      $ENDIF  
      $IF($DEF(HIL))
        $IF(HIL='N') $HIL='NO'
        $IF(HIL='Y') $HIL='YES'
        $IF(HIL='E') $HIL='EXTENDED'
      $ELSE
        $HIL='NO'  
      $ENDIF  
      $HELP
        SPECIFICATION OF THE COLOR MAP
          N - COLOR MAP SUPPRESSED
          Y - COLOR MAP REQUIRED
          E - EXTENDED COLOR MAP REQUIRED
      $CHECK(MAP,'N','NO\N\YES\Y\EXTENDED\E',1,NO)
      $IF(MAP='N') $MAP='NO'
      $IF(MAP='Y') $MAP='YES'
      $IF(MAP='E') $MAP='EXTENDED'
      $IF(MAP='NO')  
         $IF(ISO<>'NO') $MAP=ISO
         $IF(HIL<>'NO') $MAP=HIL
      $ENDIF
      $IF(MAP<>'EXTENDED')
         $IF(ISO='EXTENDED') $MAP=ISO
         $IF(HIL='EXTENDED') $MAP=HIL
      $ENDIF
      $RELIEF='NO'
      $IF(MAP<>'NO')
        $RELIEF=MAP
        $IF(PATH='EXTENDED')
          $MAP='EXTENDED'
          $RELIEF='EXTENDED'
        $ENDIF
      $ENDIF
      $IF(PATH<>'NO')
        $RELIEF=PATH
        $IF(MAP='EXTENDED')
          $PATH='EXTENDED'
          $RELIEF='EXTENDED'
        $ENDIF
      $ENDIF
    $ELSE
      $DEFAULT=0
      $IF(PATH='NO') $DEFAULT=1
      $IF(DEFAULT=0)
        $HELP
          SPECIFICATION OF THE COLOR MAP
            N - COLOR MAP SUPPRESSED
            Y - COLOR MAP REQUIRED
        $CHECK(MAP,'N','NO\N\YES\Y',1,NO)
        $IF(MAP='N') $MAP='NO'
        $IF(MAP='Y') $MAP='YES'
      $ELSE
        $HELP
          SPECIFICATION OF THE COLOR MAP
            N - COLOR MAP SUPPRESSED
            Y - COLOR MAP REQUIRED
            E - EXTENDED COLOR MAP REQUIRED
        $CHECK(MAP,'N','NO\N\YES\Y\EXTENDED\E',1,NO)
        $IF(MAP='N') $MAP='NO'
        $IF(MAP='Y') $MAP='YES'
        $IF(MAP='E') $MAP='EXTENDED'
      $ENDIF
      $IF(MAP<>'NO')
        $FL='FL'
        $IFL='IFL'
        $COLEV='COLEV'
        $ADD(INIT)
          ICOLOR=$COLOR
        $ENDADD
      $ENDIF
      $IF(MAP<>'EXTENDED')
        $HELP
          SPECIFICATION OF THE CONTOUR PICTURE
            N - NO ISOLINES
            Y - ISOLINES DISPLAYED
        $CHECK(ISO,'N','NO\N\YES\Y',1,NO)
        $IF(ISO='N') $ISO='NO'
        $IF(ISO='Y') $ISO='YES'
        $HELP
          SPECIFICATION OF THE HILL PICTURE
            N - NO HILLS
            Y - HILLS DISPLAYED
        $CHECK(HIL,'N','NO\N\YES\Y',1,NO)
        $IF(HIL='N') $HIL='NO'
        $IF(HIL='Y') $HIL='YES'
      $ELSE
        $ISO='NO'
        $HIL='NO'
      $ENDIF
      $IF(HIL<>'NO')
        $HELP
          NUMBER
        $CHECK(NPH,250,INT,1)
      $ENDIF
      $RELIEF='NO'
      $IF(MAP='YES') $RELIEF='YES'
      $IF(ISO='YES') $RELIEF='YES'
      $IF(HIL='YES') $RELIEF='YES'
      $IF(PATH<>'NO') $RELIEF='YES'
    $ENDIF
    $SUBST('UZSETG')
    $IF(RELIEF<>'NO')
      $FL='FL'
      $HELP
        NUMBER OF NODES USED IN THE RELIEF
      $CHECK(NGR,100,INT,1)
    $ELSEIF(MAP='EXTENDED') 
      $FL='FL'
      $HELP
        NUMBER OF NODES USED IN THE RELIEF
      $CHECK(NGR,100,INT,1)
    $ELSE  
      $NGR=0
    $ENDIF
  $ENDIF
  $DEFAULT=1
  $IF($DEF(NF))
    $IF(NF>40) $DEFAULT=0
  $ENDIF
  $IF(COLLECTION<>'NO') $DEFAULT=0
  $HELP
    LEVEL OF BASIC SCREEN OUTPUT
       ABS(NOUT)=0 - BASIC FINAL OUTPUT
       ABS(NOUT)=1 - EXTENDED FINAL OUTPUT: VARIABLES
       ABS(NOUT)=2 - EXTENDED FINAL OUTPUT: VARIABLES AND CONSTRAINTS
  $CHECK(NOUT,DEFAULT,'-2\-1\0\1\2',1)

  $IF(DIALOG>0)
    $HELP
      SELECTION OF OPTIMIZATION METHOD
         1 - AUTOMATICAL SELECTION OF METHOD
         2 - MANUAL SELECTION OF METHOD
         3 - MANUAL SELECTION OF METHOD AND IMPORTANT PARAMETERS
         4 - MANUAL SELECTION OF METHOD AND ALL PARAMETERS
    $CHECK(MSELECT,1,'1\2\3\4',1,NO)
    $OPTION(DIALOG=MSELECT)
    $ERASE(MSELECT)
  $ENDIF

  $HELP
    PRINT OF SPARSITY PATTERN
      N - PRINT IS SUPPRESSED
      Y - PRINT OF SPARSITY PATTERN
  $CHECK(PATTERN,'N','NO\N\YES\Y',4,NO)
  $IF(PATTERN='N') $PATTERN='NO'
  $IF(PATTERN='Y') $PATTERN='YES'
  $IF(PATTERN='YES')
    OPEN(5,FILE='P.PAT',STATUS='UNKNOWN')
  $ENDIF

  $HELP
    PERFORM TRACING:
      N - NO TRACING
      Y - TRACING IN THE CONTROL PROGRAM
  $CHECK(TRACE,'N','NO\N\YES\Y',4,NO)
  $IF(TRACE='N') $TRACE='NO'
  $IF(TRACE='Y') $TRACE='YES'
  $IF(TRACE='YES')
    $HELP
      WANT YOU PRINT SOME INTEGER VARIABLES ? IF YES GIVE 'LIST'
      WHERE LIST CONTAINS NAMES OF INTEGER VARIABLES SEPARATED
      BY COMAS. EXAMPLE:

        ITERM,ITERS,KIT,LIT
    $CHECK(IDEB,' ',STR,4,NO)
    $HELP
      WANT YOU PRINT SOME REAL VARIABLES ? IF YES GIVE 'LIST'
      WHERE LIST CONTAINS NAMES OF REAL VARIABLES SEPARATED
      BY COMAS. EXAMPLE:

        GNORM,R,F
    $CHECK(RDEB,' ',STR,4,NO)
  $ENDIF

  $HELP
    USE LAPACK SUBROUTINES
      N - ONLY UFO SUBROUTINES
      Y - CONNECTION TO LAPACK POSSIBLE
  $CHECK(LAPACK,'N','NO\N\YES\Y',1,NO)
  $IF(LAPACK='N') $LAPACK='NO'
  $IF(LAPACK='Y') $LAPACK='YES'
  $IF(TEST<>'ONLY')
    $IF(COLLECTION='NO')
      CALL UOTES1('$$CLASS$NMET','$$TYPE$NMET','$$DECOMP$NMET'&
,'$$NUMBER$NMET','$$UPDATE$NMET',  '$$MODEL$NMET','$$HESF$NMET',NF)
    $ELSE
*      WRITE(*,*) 'ETA5 = ',ETA5
*      READ(*,*) ETA5
*      WRITE(*,*) 'RPF1 = ',RPF1
*      READ(*,*) RPF1
*      WRITE(*,*) 'XMAX = ',XMAX
*      READ(*,*) XMAX
      IF (NEXT.EQ.1.AND.NCYC.EQ.1) THEN
      $IF($DEF(NF))
        CALL UOTES1('$$CLASS$NMET','$$TYPE$NMET','$$DECOMP$NMET'&
,'$$NUMBER$NMET','$$UPDATE$NMET',  '$$MODEL$NMET','$$HESF$NMET',$NF)
      $ELSE
        CALL UOTES1('$$CLASS$NMET','$$TYPE$NMET','$$DECOMP$NMET'&
,'$$NUMBER$NMET','$$UPDATE$NMET',  '$$MODEL$NMET','$$HESF$NMET',0)
      $ENDIF
      ENDIF
    $ENDIF
  $ENDIF
  
  $RECURSIVE='NO'
  $IF(EXTREM='L')
    $SUBST('UZLMIN')
  $ELSEIF(EXTREM='G')
    $SUBST('UZGMIN')
  $ELSE
    $SUBST('U1EDD1')
  $ENDIF
  $IF($DEF(CLASS))
  $ELSE
    $CLASS='NO'
  $ENDIF
  $IF($DEF(TYPE))
  $ELSE
    $TYPE='NO'
  $ENDIF
  $IF($DEF(DECOMP))
  $ELSE
    $DECOMP='NO'
  $ENDIF
  $IF($DEF(NUMBER))
  $ELSE
    $NUMBER=0
  $ENDIF
  $IF($DEF(UPDATE))
  $ELSE
    $UPDATE='NO'
  $ENDIF
$REM   $IF($DEF(SCAN))
$REM     $IF(SCAN='YES')
$REM       $LSC CONTINUE
$REM     $ENDIF
$REM   $ENDIF

  $IF(TEST='AFTER') $SUBST('UZTEST')
  *
  *     -----------------
  *     END OF METHOD ($NMET)
  *     -----------------
  *
$ENDIF

$ADD(INIT)
  CALL UYPARS
  END
$ENDADD

$SET(UYINT$NMET=INIT)
$ADD(LISTUYINT,'\UYINT$NMET')
$SET(SINIT$NMET=SINIT)
$SET(SINID$NMET=SINID)

$IF(TEST<>'ONLY')
  $SET(CLASS$NMET=CLASS)
  $SET(TYPE$NMET=TYPE)
  $SET(DECOMP$NMET=DECOMP)
  $SET(NUMBER$NMET=NUMBER)
  $SET(UPDATE$NMET=UPDATE)
  $SET(MODEL$NMET=MODEL)
  $SET(HESF$NMET=HESF)
$ENDIF

$IF($DEF(NEWRUN))
  $IF(NEWRUN)
    $IF($DEF(ENDCYCLE)) $ENDCYCLE
  $ENDIF
$ENDIF

$IF($DEF(PATTERN))
  $IF(PATTERN='YES')
    CLOSE(5)
  $ENDIF
$ENDIF


